package org.yglib.html.lexer;
import java.io.*;
import java.util.*;

import org.yglib.html.elements.*;

public class Lexer {
	
	private Page page = null;
	private TagNode latestTag;
	public Lexer(File sourceFile) throws IOException
	{
		this.page = new Page(sourceFile);
	}
	
	public Node getNextToken()
	{
		char ch;
		while((ch=this.page.getNextChar()) != (char)Page.EOF)
		{
			// processing of the 'Script' value
			
			if(this.latestTag != null)
			{
				//System.out.println("latest Tag :" + this.latestTag.getTagName());
				if(this.latestTag.getTagName().equalsIgnoreCase("script"))
				{
					//System.out.println("========= Script Value Parsing..");
					this.page.setCursor(-1);
					TextNode node = new TextNode(this.page, this.latestTag);
					node.parse();
					this.latestTag = null;
					return node;
				}
			}
						
			//System.out.println("ch >>" + ch);
			if(ch == '<')
			{
				this.page.setCursor(-1);
				//System.out.println("Current Cursor :" + this.page.getCursor());
				TagNode node = this.parseTag();
				//System.out.println("TAG =====================" + this.page.getCurrentChar());
				//System.out.println("Tag Name:" + node.getTagName());
				if(!node.isClosedTag())	this.latestTag = node;
				else this.latestTag = null;
				
				return node;
			}
			else if(Character.isLetterOrDigit(ch))
			{
				TextNode node = null;
				// script ּó ʿ
				this.page.setCursor(-1);
				if(this.latestTag != null)
				{
					System.out.println("latest Tag :" + this.latestTag.getTagName());
					if(this.latestTag.getTagName().equalsIgnoreCase("script"))
					{
						System.out.println("========= Script Value Parsing..");
						node = new TextNode(this.page, this.latestTag);
					}
					else
						node = new TextNode(this.page, null);
				}
				else
				{
					node = new TextNode(this.page, null);
				}
				node.parse();
				return node;
			}
			else 
			{
				//  lineCh 
				;
			}
			
		}
		return null;
	}
	
	private TagNode parseTag()
	{
		TagNode tagNode = new TagNode(this.page);
		tagNode.parse();
		return tagNode;
	}
	
	public static void main(String...v)
	{
		try
		{
			File file = new File("d:\\naverSample.html");
			Lexer lexer = new Lexer(file);
			Node node = null;
			while((node = lexer.getNextToken()) != null)
			{
				if(node instanceof TagNode)
				{
					String isClosed = "";
					TagNode tag = (TagNode)node;
					if(tag.isClosedTag()) isClosed = "/";
					//System.out.println("tag>" + isClosed + tag.getTagName());
					System.out.println("tag>" + tag);
				}
				else if(node instanceof TextNode)
				{
					TextNode txNode = (TextNode)node;
					System.out.println("text>" + txNode.getParsedText());
				}
			}
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
	}
	
}
