package org.yglib.html.lexer;
import java.util.*;
import java.io.*;
import org.apache.log4j.*;

public class Page {
	
	static Logger logger = Logger.getLogger(Page.class);
	public static int EOF = -1;
	private StringBuffer sBuf = null;
	private int cursor;
	
	public Page(File sourceFile) throws IOException
	{
		this.loadDataFile(sourceFile);
	}
	
	private void loadDataFile(File file) throws IOException
	{
		this.cursor = 0;
		BufferedReader br = new BufferedReader(new FileReader(file));
		String line = null;
		this.sBuf = new StringBuffer();
		while((line=br.readLine()) != null)
		{
			this.sBuf.append(line + "\r\n");
		}
		this.sBuf.trimToSize();
		br.close();
	}
	
	public char getCurrentChar()
	{
		return this.sBuf.charAt(this.cursor);
	}
		
	public char getNextChar()
	{
		//System.out.println("sBuf capacity :" + sBuf.capacity());
		if(this.cursor < sBuf.capacity())
			return this.sBuf.charAt(this.cursor++);
		else
		{
			//System.out.println("cursor : capa = " + this.cursor + " : " + sBuf.capacity());
			return (char)EOF;
		}
	}
	
	public int getCursor()
	{
		return this.cursor;
	}
	
	public char getChar(int index)
	{
		return this.sBuf.charAt(index);
	}
	
	public String getSubString(int start, int end)
	{
		if(end > start)
		{
			String strRet = "";
			for(int i=start; i <= end; i++)
				strRet += getChar(i);
			
			return strRet;
		}
		else
		{
			return null;
		}
	}
	
	public boolean setCursor(int offset)
	{
		if(this.cursor+offset >= 0 
				&& this.cursor+offset < this.sBuf.capacity())
		{
			this.cursor += offset;
			return true;
		}
		return false;
	}
	
	public static void main(String...v)
	{
		File sourceFile = new File("d:\\naverSample.html");
		try {
			Page page = new Page(sourceFile);
			char ch = 0;
			logger.debug("Get chars..");
			while((ch = page.getNextChar()) != (char)EOF)
			{
				System.out.print(ch);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
